Index: /branches/2014/dev_r4765_CNRS_agrif/NEMOGCM/NEMO/NST_SRC/agrif_opa_sponge.F90
===================================================================
--- /branches/2014/dev_r4765_CNRS_agrif/NEMOGCM/NEMO/NST_SRC/agrif_opa_sponge.F90	(revision 4788)
+++ /branches/2014/dev_r4765_CNRS_agrif/NEMOGCM/NEMO/NST_SRC/agrif_opa_sponge.F90	(revision 4789)
@@ -1,5 +1,5 @@
 #define SPONGE && define SPONGE_TOP
 
-Module agrif_opa_sponge
+MODULE agrif_opa_sponge
 #if defined key_agrif  && ! defined key_offline
    USE par_oce
@@ -16,5 +16,5 @@
    PUBLIC interptsn_sponge, interpun_sponge, interpvn_sponge
 
-  !! * Substitutions
+   !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
@@ -24,5 +24,5 @@
    !!----------------------------------------------------------------------
 
-   CONTAINS
+CONTAINS
 
    SUBROUTINE Agrif_Sponge_Tra
@@ -31,18 +31,13 @@
       !!---------------------------------------------
       !!
-      INTEGER :: ji,jj,jk,jn
       REAL(wp) :: timecoeff
-      REAL(wp) :: ztsa, zabe1, zabe2, zbtr
-      REAL(wp), POINTER, DIMENSION(:,:    ) :: ztu, ztv
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztab
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: tsbdiff
 
 #if defined SPONGE
       timecoeff = REAL(Agrif_NbStepint(),wp)/Agrif_rhot()
-      
+
       CALL Agrif_Sponge
       Agrif_SpecialValue=0.
       Agrif_UseSpecialValue = .TRUE.
-      tabspongedone = .FALSE.
+      tabspongedone_tsn = .FALSE.
 
       CALL Agrif_Bc_Variable(tsn_sponge_id,calledweight=timecoeff,procname=interptsn_sponge)
@@ -63,16 +58,16 @@
       timecoeff = REAL(Agrif_NbStepint(),wp)/Agrif_rhot()
 
-         Agrif_SpecialValue=0.
-         Agrif_UseSpecialValue = ln_spc_dyn
-
-         tabspongedone_u = .FALSE.
-         tabspongedone_v = .FALSE.         
-         CALL Agrif_Bc_Variable(un_sponge_id,calledweight=timecoeff,procname=interpun_sponge)
-
-         tabspongedone_u = .FALSE.
-         tabspongedone_v = .FALSE.
-         CALL Agrif_Bc_Variable(vn_sponge_id,calledweight=timecoeff,procname=interpvn_sponge)
-
-         Agrif_UseSpecialValue = .FALSE.
+      Agrif_SpecialValue=0.
+      Agrif_UseSpecialValue = ln_spc_dyn
+
+      tabspongedone_u = .FALSE.
+      tabspongedone_v = .FALSE.         
+      CALL Agrif_Bc_Variable(un_sponge_id,calledweight=timecoeff,procname=interpun_sponge)
+
+      tabspongedone_u = .FALSE.
+      tabspongedone_v = .FALSE.
+      CALL Agrif_Bc_Variable(vn_sponge_id,calledweight=timecoeff,procname=interpvn_sponge)
+
+      Agrif_UseSpecialValue = .FALSE.
 #endif
 
@@ -109,9 +104,9 @@
             ENDDO
             spe1ur(2:ispongearea-1,:      ) = 0.5 * ( zlocalviscsponge(2:ispongearea-1,:      )   &
-               &                         +            zlocalviscsponge(3:ispongearea  ,:      ) ) &
-               &                         * e2u(2:ispongearea-1,:      ) / e1u(2:ispongearea-1,:      )
+                  &                         +            zlocalviscsponge(3:ispongearea  ,:      ) ) &
+                  &                         * e2u(2:ispongearea-1,:      ) / e1u(2:ispongearea-1,:      )
             spe2vr(2:ispongearea  ,1:jpjm1) = 0.5 * ( zlocalviscsponge(2:ispongearea  ,1:jpjm1)   &
-               &                         +            zlocalviscsponge(2:ispongearea,2  :jpj  ) ) &
-               &                         * e1v(2:ispongearea  ,1:jpjm1) / e2v(2:ispongearea  ,1:jpjm1)
+                  &                         +            zlocalviscsponge(2:ispongearea,2  :jpj  ) ) &
+                  &                         * e1v(2:ispongearea  ,1:jpjm1) / e2v(2:ispongearea  ,1:jpjm1)
          ENDIF
 
@@ -120,12 +115,12 @@
                zlocalviscsponge(ji,:) = visc_tra * (ji - (ilci+1) ) * z1spongearea
             ENDDO
-  
+
             spe1ur(ilci+1:nlci-2,:      ) = 0.5 * (  zlocalviscsponge(ilci+1:nlci-2,:)    & 
-               &                          +          zlocalviscsponge(ilci+2:nlci-1,:) )  &
-               &                          * e2u(ilci+1:nlci-2,:) / e1u(ilci+1:nlci-2,:)
+                  &                          +          zlocalviscsponge(ilci+2:nlci-1,:) )  &
+                  &                          * e2u(ilci+1:nlci-2,:) / e1u(ilci+1:nlci-2,:)
 
             spe2vr(ilci+1:nlci-1,1:jpjm1) = 0.5 * (  zlocalviscsponge(ilci+1:nlci-1,1:jpjm1)    & 
-               &                            +        zlocalviscsponge(ilci+1:nlci-1,2:jpj  )  ) & 
-               &                                   * e1v(ilci+1:nlci-1,1:jpjm1) / e2v(ilci+1:nlci-1,1:jpjm1)
+                  &                            +        zlocalviscsponge(ilci+1:nlci-1,2:jpj  )  ) & 
+                  &                                   * e1v(ilci+1:nlci-1,1:jpjm1) / e2v(ilci+1:nlci-1,1:jpjm1)
          ENDIF
 
@@ -135,10 +130,10 @@
             ENDDO
             spe1ur(1:jpim1,2:ispongearea  ) = 0.5 * ( zlocalviscsponge(1:jpim1,2:ispongearea  ) & 
-               &                            +         zlocalviscsponge(2:jpi  ,2:ispongearea) ) &
-               &                            * e2u(1:jpim1,2:ispongearea) / e1u(1:jpim1,2:ispongearea)
-   
+                  &                            +         zlocalviscsponge(2:jpi  ,2:ispongearea) ) &
+                  &                            * e2u(1:jpim1,2:ispongearea) / e1u(1:jpim1,2:ispongearea)
+
             spe2vr(:      ,2:ispongearea-1) = 0.5 * ( zlocalviscsponge(:,2:ispongearea-1)       &
-               &                            +         zlocalviscsponge(:,3:ispongearea  )     ) &
-               &                            * e1v(:,2:ispongearea-1) / e2v(:,2:ispongearea-1)
+                  &                            +         zlocalviscsponge(:,3:ispongearea  )     ) &
+                  &                            * e1v(:,2:ispongearea-1) / e2v(:,2:ispongearea-1)
          ENDIF
 
@@ -148,9 +143,9 @@
             ENDDO
             spe1ur(1:jpim1,ilcj+1:nlcj-1) = 0.5 * ( zlocalviscsponge(1:jpim1,ilcj+1:nlcj-1)   &
-               &                          +         zlocalviscsponge(2:jpi  ,ilcj+1:nlcj-1) ) &
-               &                                * e2u(1:jpim1,ilcj+1:nlcj-1) / e1u(1:jpim1,ilcj+1:nlcj-1)
+                  &                          +         zlocalviscsponge(2:jpi  ,ilcj+1:nlcj-1) ) &
+                  &                                * e2u(1:jpim1,ilcj+1:nlcj-1) / e1u(1:jpim1,ilcj+1:nlcj-1)
             spe2vr(:      ,ilcj+1:nlcj-2) = 0.5 * ( zlocalviscsponge(:,ilcj+1:nlcj-2      )   &
-               &                          +         zlocalviscsponge(:,ilcj+2:nlcj-1)     )   &
-               &                                * e1v(:,ilcj+1:nlcj-2) / e2v(:,ilcj+1:nlcj-2)
+                  &                          +         zlocalviscsponge(:,ilcj+2:nlcj-1)     )   &
+                  &                                * e1v(:,ilcj+1:nlcj-2) / e2v(:,ilcj+1:nlcj-2)
          ENDIF
          spongedoneT = .TRUE.
@@ -168,7 +163,7 @@
             ENDDO
             spe1ur2(2:ispongearea-1,:      ) = 0.5 * ( zlocalviscsponge(2:ispongearea-1,:      ) &
-                                             &     +   zlocalviscsponge(3:ispongearea,:    ) )
+                  &     +   zlocalviscsponge(3:ispongearea,:    ) )
             spe2vr2(2:ispongearea  ,1:jpjm1) = 0.5 * ( zlocalviscsponge(2:ispongearea  ,1:jpjm1) &
-                                             &     +   zlocalviscsponge(2:ispongearea,2:jpj) ) 
+                  &     +   zlocalviscsponge(2:ispongearea,2:jpj) ) 
          ENDIF
 
@@ -178,7 +173,7 @@
             ENDDO
             spe1ur2(ilci+1:nlci-2,:      ) = 0.5 * (  zlocalviscsponge(ilci+1:nlci-2,:) &
-                                           &        + zlocalviscsponge(ilci+2:nlci-1,:) )  
+                  &        + zlocalviscsponge(ilci+2:nlci-1,:) )  
             spe2vr2(ilci+1:nlci-1,1:jpjm1) = 0.5 * (  zlocalviscsponge(ilci+1:nlci-1,1:jpjm1) &
-                                           &        + zlocalviscsponge(ilci+1:nlci-1,2:jpj  )  ) 
+                  &        + zlocalviscsponge(ilci+1:nlci-1,2:jpj  )  ) 
          ENDIF
 
@@ -188,7 +183,7 @@
             ENDDO
             spe1ur2(1:jpim1,2:ispongearea  ) = 0.5 * ( zlocalviscsponge(1:jpim1,2:ispongearea) &
-                                             &      + zlocalviscsponge(2:jpi,2:ispongearea) ) 
+                  &      + zlocalviscsponge(2:jpi,2:ispongearea) ) 
             spe2vr2(:      ,2:ispongearea-1) = 0.5 * ( zlocalviscsponge(:,2:ispongearea-1)     &
-                                             &      + zlocalviscsponge(:,3:ispongearea)     )
+                  &      + zlocalviscsponge(:,3:ispongearea)     )
          ENDIF
 
@@ -198,7 +193,7 @@
             ENDDO
             spe1ur2(1:jpim1,ilcj+1:nlcj-1) = 0.5 * ( zlocalviscsponge(1:jpim1,ilcj+1:nlcj-1) &
-                                           &         + zlocalviscsponge(2:jpi,ilcj+1:nlcj-1) ) 
+                  &         + zlocalviscsponge(2:jpi,ilcj+1:nlcj-1) ) 
             spe2vr2(:      ,ilcj+1:nlcj-2) = 0.5 * ( zlocalviscsponge(:,ilcj+1:nlcj-2      ) &
-                                           &         + zlocalviscsponge(:,ilcj+2:nlcj-1)     )
+                  &         + zlocalviscsponge(:,ilcj+2:nlcj-1)     )
          ENDIF
          spongedoneU = .TRUE.
@@ -219,6 +214,6 @@
       REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2,n1:n2), INTENT(inout) :: tabres
       LOGICAL, INTENT(in) :: before
-       
-     
+
+
       INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
 
@@ -227,44 +222,44 @@
       REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2,n1:n2) ::tsbdiff
       !
-         
-         
-         IF (before) THEN
-            tabres(i1:i2,j1:j2,k1:k2,n1:n2) = tsn(i1:i2,j1:j2,k1:k2,n1:n2)
-         ELSE      
-
-            tsbdiff(:,:,:,:) = tsb(i1:i2,j1:j2,:,:) - tabres(:,:,:,:)      
-            DO jn = 1, jpts
-               DO jk = 1, jpkm1
-                 
-                  DO jj = j1,j2-1
-                     DO ji = i1,i2-1
-                        zabe1 = umask(ji,jj,jk) * spe1ur(ji,jj) * fse3u(ji,jj,jk)
-                        zabe2 = vmask(ji,jj,jk) * spe2vr(ji,jj) * fse3v(ji,jj,jk)
-                        ztu(ji,jj) = zabe1 * ( tsbdiff(ji+1,jj  ,jk,jn) - tsbdiff(ji,jj,jk,jn) )
-                        ztv(ji,jj) = zabe2 * ( tsbdiff(ji  ,jj+1,jk,jn) - tsbdiff(ji,jj,jk,jn) )
-                     ENDDO
+
+
+      IF (before) THEN
+         tabres(i1:i2,j1:j2,k1:k2,n1:n2) = tsn(i1:i2,j1:j2,k1:k2,n1:n2)
+      ELSE      
+
+         tsbdiff(:,:,:,:) = tsb(i1:i2,j1:j2,:,:) - tabres(:,:,:,:)      
+         DO jn = 1, jpts
+            DO jk = 1, jpkm1
+
+               DO jj = j1,j2-1
+                  DO ji = i1,i2-1
+                     zabe1 = umask(ji,jj,jk) * spe1ur(ji,jj) * fse3u(ji,jj,jk)
+                     zabe2 = vmask(ji,jj,jk) * spe2vr(ji,jj) * fse3v(ji,jj,jk)
+                     ztu(ji,jj) = zabe1 * ( tsbdiff(ji+1,jj  ,jk,jn) - tsbdiff(ji,jj,jk,jn) )
+                     ztv(ji,jj) = zabe2 * ( tsbdiff(ji  ,jj+1,jk,jn) - tsbdiff(ji,jj,jk,jn) )
                   ENDDO
-                  
-                  DO jj = j1+1,j2-1
-                     DO ji = i1+1,i2-1
-                        
-                        if (.not. tabspongedone(ji,jj)) then 
-                           zbtr = spbtr2(ji,jj) / fse3t(ji,jj,jk)
-			   ! horizontal diffusive trends
-                           ztsa = zbtr * (  ztu(ji,jj) - ztu(ji-1,jj  ) + ztv(ji,jj) - ztv(ji  ,jj-1)  )
-			   ! add it to the general tracer trends
-                           tsa(ji,jj,jk,jn) = tsa(ji,jj,jk,jn) + ztsa
-                         endif 
- 
-                       ENDDO
-                    ENDDO
-                    
-                ENDDO
-             ENDDO
-             
-             tabspongedone(i1+1:i2-1,j1+1:j2-1) = .TRUE.
-                         
-	 ENDIF
-                
+               ENDDO
+
+               DO jj = j1+1,j2-1
+                  DO ji = i1+1,i2-1
+
+                     IF (.NOT. tabspongedone_tsn(ji,jj)) THEN 
+                        zbtr = spbtr2(ji,jj) / fse3t(ji,jj,jk)
+                        ! horizontal diffusive trends
+                        ztsa = zbtr * (  ztu(ji,jj) - ztu(ji-1,jj  ) + ztv(ji,jj) - ztv(ji  ,jj-1)  )
+                        ! add it to the general tracer trends
+                        tsa(ji,jj,jk,jn) = tsa(ji,jj,jk,jn) + ztsa
+                     ENDIF
+
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+         tabspongedone_tsn(i1+1:i2-1,j1+1:j2-1) = .TRUE.
+
+      ENDIF
+
    END SUBROUTINE interptsn_sponge
 
@@ -279,20 +274,20 @@
       INTEGER :: ji,jj,jk
 
-	! sponge parameters 
+      ! sponge parameters 
       REAL(wp) :: ze2u, ze1v, zua, zva, zbtr
       REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2) :: ubdiff
       REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2) :: rotdiff, hdivdiff
       INTEGER :: jmax
-	!
-      
+      !
+
 
       IF (before) THEN
-          
-          tabres = un(i1:i2,j1:j2,:)
+
+         tabres = un(i1:i2,j1:j2,:)
 
       ELSE
-         
+
          ubdiff(i1:i2,j1:j2,:) = (ub(i1:i2,j1:j2,:) - tabres(:,:,:))*umask(i1:i2,j1:j2,:)
-	      
+
          DO jk=1,jpkm1
             ubdiff(i1:i2,j1:j2,jk) = ubdiff(i1:i2,j1:j2,jk) * spe1ur2(i1:i2,j1:j2)
@@ -300,14 +295,14 @@
 
          DO jk = 1, jpkm1                                 ! Horizontal slab
-!                                             ! ===============
-
-!                                             ! --------
-! Horizontal divergence                       !   div
-!                                             ! --------
+            !                                             ! ===============
+
+            !                                             ! --------
+            ! Horizontal divergence                       !   div
+            !                                             ! --------
             DO jj = j1,j2
                DO ji = i1+1,i2   ! vector opt.
                   zbtr = spbtr2(ji,jj) / fse3t(ji,jj,jk)
                   hdivdiff(ji,jj,jk) = (e2u(ji,jj)*fse3u(ji,jj,jk) * ubdiff(ji,jj,jk) - e2u(ji-1,jj)* fse3u(ji-1,jj  ,jk)  &
-                                       * ubdiff(ji-1,jj  ,jk) ) * zbtr
+                        * ubdiff(ji-1,jj  ,jk) ) * zbtr
                END DO
             END DO
@@ -317,69 +312,69 @@
                   zbtr = spbtr3(ji,jj) * fse3f(ji,jj,jk)
                   rotdiff(ji,jj,jk) = (- e1u(ji  ,jj+1) * ubdiff(ji  ,jj+1,jk) + e1u(ji,jj) * ubdiff(ji,jj,jk)  ) &
-                                      * fmask(ji,jj,jk) * zbtr 
+                        * fmask(ji,jj,jk) * zbtr 
                END DO
             END DO
          ENDDO
 
-!
-
-
-
-            DO jj = j1+1, j2-1
-               DO ji = i1+1, i2-1   ! vector opt.
-                  
-                  if (.not. tabspongedone_u(ji,jj)) then
-                     DO jk = 1, jpkm1                                 ! Horizontal slab
-                        ze2u = rotdiff (ji,jj,jk)
-                        ze1v = hdivdiff(ji,jj,jk)
-! horizontal diffusive trends
-                        zua = - ( ze2u - rotdiff (ji,jj-1,jk)) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )   &
-                        + ( hdivdiff(ji+1,jj,jk) - ze1v  ) / e1u(ji,jj)
-
-! add it to the general momentum trends
-                        ua(ji,jj,jk) = ua(ji,jj,jk) + zua
-
-                     END DO                  
-                  endif 
-
-               END DO            
-            END DO
-                  
-            tabspongedone_u(i1+1:i2-1,j1+1:j2-1) = .true.
- 
+         !
+
+
+
+         DO jj = j1+1, j2-1
+            DO ji = i1+1, i2-1   ! vector opt.
+
+               IF (.NOT. tabspongedone_u(ji,jj)) THEN
+                  DO jk = 1, jpkm1                                 ! Horizontal slab
+                     ze2u = rotdiff (ji,jj,jk)
+                     ze1v = hdivdiff(ji,jj,jk)
+                     ! horizontal diffusive trends
+                     zua = - ( ze2u - rotdiff (ji,jj-1,jk)) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )   &
+                           + ( hdivdiff(ji+1,jj,jk) - ze1v  ) / e1u(ji,jj)
+
+                     ! add it to the general momentum trends
+                     ua(ji,jj,jk) = ua(ji,jj,jk) + zua
+
+                  END DO
+               ENDIF
+
+            END DO
+         END DO
+
+         tabspongedone_u(i1+1:i2-1,j1+1:j2-1) = .TRUE.
+
          jmax = j2-1
-         If ((nbondj == 1).OR.(nbondj == 2)) jmax = min(jmax,nlcj-3)
-                                
-            DO jj = j1+1, jmax
-               DO ji = i1+1, i2   ! vector opt.
-                  
-                  if (.not. tabspongedone_v(ji,jj)) then
-                     DO jk = 1, jpkm1                                 ! Horizontal slab
-                        ze2u = rotdiff (ji,jj,jk)
-                        ze1v = hdivdiff(ji,jj,jk)
-                        
-! horizontal diffusive trends
-                        zva = + ( ze2u - rotdiff (ji-1,jj,jk)) / ( e1v(ji,jj) * fse3v(ji,jj,jk) )   &
-                        + ( hdivdiff(ji,jj+1,jk) - ze1v  ) / e2v(ji,jj)
-
-! add it to the general momentum trends
-                        va(ji,jj,jk) = va(ji,jj,jk) + zva
-                     END DO                  
-                  endif 
-
-               END DO            
-            END DO
-
-            
-            tabspongedone_v(i1+1:i2,j1+1:jmax) = .true.
-            
+         IF ((nbondj == 1).OR.(nbondj == 2)) jmax = MIN(jmax,nlcj-3)
+
+         DO jj = j1+1, jmax
+            DO ji = i1+1, i2   ! vector opt.
+
+               IF (.NOT. tabspongedone_v(ji,jj)) THEN
+                  DO jk = 1, jpkm1                                 ! Horizontal slab
+                     ze2u = rotdiff (ji,jj,jk)
+                     ze1v = hdivdiff(ji,jj,jk)
+
+                     ! horizontal diffusive trends
+                     zva = + ( ze2u - rotdiff (ji-1,jj,jk)) / ( e1v(ji,jj) * fse3v(ji,jj,jk) )   &
+                           + ( hdivdiff(ji,jj+1,jk) - ze1v  ) / e2v(ji,jj)
+
+                     ! add it to the general momentum trends
+                     va(ji,jj,jk) = va(ji,jj,jk) + zva
+                  END DO
+               ENDIF
+
+            END DO
+         END DO
+
+
+         tabspongedone_v(i1+1:i2,j1+1:jmax) = .TRUE.
+
       ENDIF
-      	
-          
+
+
    END SUBROUTINE interpun_sponge
- 
-   
+
+
    SUBROUTINE interpvn_sponge(tabres,i1,i2,j1,j2,k1,k2, before,nb,ndir)
-     !!---------------------------------------------
+      !!---------------------------------------------
       !!   *** ROUTINE interpvn_sponge ***
       !!--------------------------------------------- 
@@ -392,16 +387,16 @@
 
       REAL(wp) :: ze2u, ze1v, zua, zva, zbtr
-      
+
       REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2) :: vbdiff
       REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2) :: rotdiff, hdivdiff
       INTEGER :: imax
-	!
-     
+      !
+
       IF (before) THEN 
-	     tabres = vn(i1:i2,j1:j2,:)
+         tabres = vn(i1:i2,j1:j2,:)
       ELSE
 
          vbdiff(i1:i2,j1:j2,:) = (vb(i1:i2,j1:j2,:) - tabres(:,:,:))*vmask(i1:i2,j1:j2,:)
-		      
+
          DO jk=1,jpkm1
             vbdiff(i1:i2,j1:j2,jk) = vbdiff(i1:i2,j1:j2,jk) * spe2vr2(i1:i2,j1:j2)
@@ -409,77 +404,72 @@
 
          DO jk = 1, jpkm1                                 ! Horizontal slab
-!                                             ! ===============
-
-!                                             ! --------
-! Horizontal divergence                       !   div
-!                                             ! --------
+            !                                             ! ===============
+
+            !                                             ! --------
+            ! Horizontal divergence                       !   div
+            !                                             ! --------
             DO jj = j1+1,j2
                DO ji = i1,i2   ! vector opt.
                   zbtr = spbtr2(ji,jj) / fse3t(ji,jj,jk)
                   hdivdiff(ji,jj,jk) = (e1v(ji,jj) * fse3v(ji,jj,jk) * vbdiff(ji,jj,jk) - e1v(ji  ,jj-1) &
-                                       * fse3v(ji  ,jj-1,jk)  * vbdiff(ji  ,jj-1,jk)  ) * zbtr
+                        * fse3v(ji  ,jj-1,jk)  * vbdiff(ji  ,jj-1,jk)  ) * zbtr
                END DO
             END DO
-
             DO jj = j1,j2
                DO ji = i1,i2-1   ! vector opt.
                   zbtr = spbtr3(ji,jj) * fse3f(ji,jj,jk)
                   rotdiff(ji,jj,jk) = (e2v(ji+1,jj  ) * vbdiff(ji+1,jj  ,jk) - e2v(ji,jj) * vbdiff(ji,jj,jk)) &
-                                      * fmask(ji,jj,jk) * zbtr
+                        * fmask(ji,jj,jk) * zbtr
                END DO
             END DO
-
          ENDDO
 
-!                                                ! ===============
-!                                                
-         
+         !                                                ! ===============
+         !                                                
+
          imax = i2-1
-         If ((nbondi == 1).OR.(nbondi == 2)) imax = min(imax,nlci-3)
-                            
-            DO jj = j1+1, j2
-               DO ji = i1+1, imax   ! vector opt.
-                  if (.not. tabspongedone_u(ji,jj)) then
-                     DO jk = 1, jpkm1                                 ! Horizontal slab
-                        ze2u = rotdiff (ji,jj,jk)
-                        ze1v = hdivdiff(ji,jj,jk)
-! horizontal diffusive trends
-                        zua = - ( ze2u - rotdiff (ji,jj-1,jk)) / ( e2u(ji,jj) * fse3u(ji,jj,jk) ) + ( hdivdiff(ji+1,jj,jk) - ze1v) &
-                        / e1u(ji,jj)
-
-
-! add it to the general momentum trends
-                       ua(ji,jj,jk) = ua(ji,jj,jk) + zua
-                     END DO
-
-                   endif
-            END DO            
-         END DO  
-  
-         tabspongedone_u(i1+1:imax,j1+1:j2) = .true.
-         
-            DO jj = j1+1, j2-1
-               DO ji = i1+1, i2-1   ! vector opt.
-                  if (.not. tabspongedone_v(ji,jj)) then
-                     DO jk = 1, jpkm1                                 ! Horizontal slab
-                        ze2u = rotdiff (ji,jj,jk)
-                        ze1v = hdivdiff(ji,jj,jk)
-! horizontal diffusive trends
-
-                        zva = + ( ze2u - rotdiff (ji-1,jj,jk)) / ( e1v(ji,jj) * fse3v(ji,jj,jk) ) + ( hdivdiff(ji,jj+1,jk) - ze1v) &
-                        / e2v(ji,jj)
-
-! add it to the general momentum trends
-                       va(ji,jj,jk) = va(ji,jj,jk) + zva
-                     END DO
-
-                   endif
-            END DO            
-         END DO          
-         
-         tabspongedone_v(i1+1:i2-1,j1+1:j2-1) = .true.
-         
+         IF ((nbondi == 1).OR.(nbondi == 2)) imax = MIN(imax,nlci-3)
+
+         DO jj = j1+1, j2
+            DO ji = i1+1, imax   ! vector opt.
+               IF (.NOT. tabspongedone_u(ji,jj)) THEN
+                  DO jk = 1, jpkm1                                 ! Horizontal slab
+                     ze2u = rotdiff (ji,jj,jk)
+                     ze1v = hdivdiff(ji,jj,jk)
+                     ! horizontal diffusive trends
+                     zua = - ( ze2u - rotdiff (ji,jj-1,jk)) / ( e2u(ji,jj) * fse3u(ji,jj,jk) ) + ( hdivdiff(ji+1,jj,jk) - ze1v) &
+                           / e1u(ji,jj)
+
+
+                     ! add it to the general momentum trends
+                     ua(ji,jj,jk) = ua(ji,jj,jk) + zua
+                  END DO
+
+               ENDIF
+            END DO
+         END DO
+
+         tabspongedone_u(i1+1:imax,j1+1:j2) = .TRUE.
+
+         DO jj = j1+1, j2-1
+            DO ji = i1+1, i2-1   ! vector opt.
+               IF (.NOT. tabspongedone_v(ji,jj)) THEN
+                  DO jk = 1, jpkm1                                 ! Horizontal slab
+                     ze2u = rotdiff (ji,jj,jk)
+                     ze1v = hdivdiff(ji,jj,jk)
+                     ! horizontal diffusive trends
+
+                     zva = + ( ze2u - rotdiff (ji-1,jj,jk)) / ( e1v(ji,jj) * fse3v(ji,jj,jk) ) + ( hdivdiff(ji,jj+1,jk) - ze1v) &
+                           / e2v(ji,jj)
+
+                     ! add it to the general momentum trends
+                     va(ji,jj,jk) = va(ji,jj,jk) + zva
+                  END DO
+               ENDIF
+            END DO
+         END DO
+         tabspongedone_v(i1+1:i2-1,j1+1:j2-1) = .TRUE.
       ENDIF
-     
+
    END SUBROUTINE interpvn_sponge
 
